require 'java'

include_class "java.lang.StringBuffer"
include_class "java.io.PipedReader"
include_class "java.io.PipedWriter"
include_class "jruby.tools.ConsoleBuffer"

#
# General purpose Console
class Console
  DEFAULT_LINE_BUFFER_SIZE = 40
  
  # ini stands for in
  attr_accessor(:ui, :ini, :out)
  
  # Constructor
  def initialize()
    super()
    @out = ConsoleBuffer.new(DEFAULT_LINE_BUFFER_SIZE)    
    @pipe = PipedWriter.new()
    @ini = PipedReader.new()
    begin
      @pipe.connect(ini)
    rescue IOException => exc
      exc.printStackTrace()
    end
  end
  
  def ui=(ui)
    @ui = ui
    @out.setUI(ui)
  end
  
  #
  # Sends the specified string to the scripting engine	
  def enter(str)
    carray = str.toCharArray()
    enter(carray, 0, carray.length)
  end
  
  #
  # Sends the specified characters to the scripting engine	
  def enter(cbuf, offset, size)
    @pipe.write(cbuf, offset, size)
    @pipe.write("\n")
    @pipe.flush()
  end
end

# 
# Already ported to JRuby, but for now we have to use java version
# 
#class ConsoleBuffer < Writer
#  
#  def initialize(lineBufferSize)
#    super()
#    @lineBufferSize = lineBufferSize
#    @buf = StringBuffer.new()
#    @pendingLines = 0
#  end
#  
#  def write(ch)
#    buf.append(ch)
#    if (@lineBufferSize > 0 && ch == '\n')
#      pendingLines += 1
#      if (++pendingLines > @lineBufferSize)
#        flushBuffer()
#        pendingLines = 0
#      end
#    end
#  end
#  
#  def write(data, off, len)
#    #for (i = off; i < len; i++)
#    data.each do |dataitem|
#      buf.append(dataitem) 
#      if (@lineBufferSize > 0 && dataitem == '\n')
#        pendingLines += 1
#        if (pendingLines > @lineBufferSize)
#          flushBuffer()
#          pendingLines = 0
#        end
#      end
#    end
#  end
#  
#  def flush()
#    if (buf.length() > 0)
#      flushBuffer()
#    end
#  end
#  
#  def close()
#    flush()
#  end
#  
#  def size()
#    buf.length()
#  end
#  
#  def flushBuffer()
#    str = buf.toString()
#    buf.setLength(0)
#    if (ui != nil)
#      ui.append(str)
#    end
#  end
#end
